//--------------------------------------------
//  CLASSES : lists of integers (1)
//--------------------------------------------
#include  <iostream.h> 
//--------------------------------------------
class cell
{public : 
   int atom; cell* next;
   cell(int at, cell* nx) : atom(at), next(nx) { }; // constructor 
   int   hd() {return atom ;};  // destructor head
   cell* tl() {return next ;};  // destructor tail
};
typedef cell* list;

//---------------- head, tail, and cons functions ----
int head(list L)
{ if (L == 0) {cout << "\n error: head of empty list \n"; } 
  else {return (*L).hd();} ; }

list tail(list L)
{ if (L == 0) {cout << "\n error: tail of empty list \n"; } 
  else {return (*L).tl();} ; }

list cons(int x, list L)
{list newlist = new cell(x,L) ; return newlist; }

//------------------ print procedures ----------------
void printlist (list L)
{if (L == 0) {cout << " nil"; return;} 
 else {cout <<  head(L) << " ";  printlist(tail(L)); };
};

void printlist1 (list L)
{if (L == 0) {cout << " nil\n"; return;} 
 else {cout  << L->atom << " "; printlist(L->next); };
}
//--------------------------------------------
void main ()
{
list list1 = new cell (12,0);  
cout << "\n list1 = "; printlist(list1);

list list2 = cons(44,list1); 
cout << "\n list2 = "; printlist1(list2);

cout << "\n head(list2) = " << head(list2);
cout << "\n tail(list2) = " ;  printlist(tail(list2)); 
cout << "\n\n";
}
//--------------------------------------------
// input:   output:
//
//           list1 = 12  nil
//           list2 = 44 12  nil
//           head(list2) = 44
//           tail(list2) = 12  nil
//            
//--------------------------------------------
